#!/usr/bin/env python3

#apt-get install libcurl4-openssl-dev
# pip3-2 install pycurl
import pycurl
import log
from io import BytesIO
from time import localtime, strftime, time
from datetime import datetime, timedelta
import xml.etree.ElementTree as ET
import traceback
import cairo

#############################################################
#Logins opendata CTS
cts_id = 00
cts_mdp = ""

#Nom des 4 arrêts CTS à afficher
################Label arrêt, numéro arrêt, Label terminus, RGB du logo
cts_stops = [ ["Hoenheim  ",24,"B Hoenheim Gare",0,0.62,0.88],
              ["Neuhof  ",197,"C Neuhof R.Reuss",0.95,0.58,0],
              ["Hautepierre  ",30,"D Poteries",0,0.60,0.195],
              ["Pont du Rhin  ",667,"2 Pont du Rhin",0.88,0,0.1]
            ]
#############################################################

def init(root_path):
   log.cat("OK!",end="")
   return

def refresh(cron):
   return

def ask_cts(arret, destination, nb):
   retour = ""
   date = strftime("%H:%M:%S", localtime())
   post_xml = "<?xml version='1.0' encoding='utf-8'?><soap12:Envelope xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xmlns:xsd='http://www.w3.org/2001/XMLSchema' xmlns:soap12='http://www.w3.org/2003/05/soap-envelope'><soap12:Header><CredentialHeader xmlns='http://www.cts-strasbourg.fr/'><ID>" + str(cts_id) + "</ID><MDP>" + str(cts_mdp) + "</MDP></CredentialHeader></soap12:Header><soap12:Body><rechercheProchainesArriveesWeb xmlns='http://www.cts-strasbourg.fr/'><CodeArret>" + str(arret) + "</CodeArret><Mode>0</Mode><Heure>" + str(date) + "</Heure><NbHoraires>" + str(nb) + "</NbHoraires></rechercheProchainesArriveesWeb></soap12:Body></soap12:Envelope>"

   try:
      buffer = BytesIO()
      c = pycurl.Curl()
      c.setopt(c.URL, 'http://opendata.cts-strasbourg.fr/webservice_v4/Service.asmx')
      c.setopt(c.CONNECTTIMEOUT, 2);
      c.setopt(c.TIMEOUT, 2);
      c.setopt(c.FOLLOWLOCATION, True)
      c.setopt(c.WRITEDATA, buffer)
      c.setopt(c.HTTPHEADER,["Content-Type: application/soap+xml; charset=utf-8"])
      c.setopt(c.POST, True);
      c.setopt(c.POSTFIELDS, post_xml); 
      c.perform()
      c.close()

      root = ET.fromstring(buffer.getvalue().decode('iso-8859-1'))
      for arrivee in root.iter("{http://www.cts-strasbourg.fr/}Arrivee"):
         if arrivee.find('{http://www.cts-strasbourg.fr/}Destination').text == destination:
            passage = arrivee.find('{http://www.cts-strasbourg.fr/}Horaire').text
            t2 = datetime.today()
            t1 = datetime.strptime(str(t2.year) + "/" + str(t2.month) + "/" +  str(t2.day) + "-" + passage,'%Y/%m/%d-%H:%M:%S')
            if arrivee.find('{http://www.cts-strasbourg.fr/}EstApresMinuit').text == "true":
               t1 = t1 + timedelta(days=1)               
            retour += t1.strftime("%H:%M") + "  "
   except Exception:
      retour = "Erreur CTS"
      print(traceback.format_exc())
   finally:
      return retour

def draw(ctx, x, y):
   global cts_stops
   max = len(cts_stops)
   
   for i in range(0, max):
      lettre = cts_stops[i][2][:1]
      ctx.move_to(x, y)
      ctx.set_source_rgba(cts_stops[i][3],cts_stops[i][4],cts_stops[i][5],1)
      ctx.rectangle(x,y,21,21)
      ctx.fill()
      
      if(lettre != "C"):
         ctx.move_to(x+7, y+16)
      else:
         ctx.move_to(x+6, y+16)      
      ctx.set_source_rgba(1, 1, 1, 1)
      ctx.select_font_face('Droid Sans', cairo.FONT_SLANT_NORMAL, cairo.FONT_WEIGHT_BOLD)
      ctx.set_font_size(14)
      ctx.text_path(lettre)

      ctx.move_to(x+25, y+17)
      ctx.select_font_face('Droid Sans')
      ctx.set_font_size(15)
      ctx.text_path(cts_stops[i][0] + ask_cts(cts_stops[i][1],cts_stops[i][2],4))
      ctx.fill()
      y = y + 28
