#!/usr/bin/env python3

# pip-3.2 install python-dateutil
from dateutil.easter import easter
from datetime import date, timedelta

import log
import cairo
from time import localtime, strftime, time
import locale

last_update = 0

fete_today = ""
fetes = [
[
"Jour de l'An","Saint Basile","Sainte Geneviève","Saint Odilon","Saint Edouard","Epiphanie","Saint Raymond","Saint Lucien","Sainte Alix","Saint Guillaume","Saint Pauline","Sainte Tatiana","Sainte Yvette","Sainte Nina","Saint Rémi","Saint Marcel","Sainte Roseline","Sainte Prisca","Saint Marius","Saint Sébastien","Sainte Agnès","Saint Vincent","Saint Barnard","Saint François de Sales","Conversion de Paul","Sainte Paule","Sainte Angèle","Saint Thomas d'Aquin","Saint Gildas","Sainte Martine","Sainte Marcelle"
],
[
"Sainte Ella","Fête de la Présention","Saint Blaise","Sainte Véronique","Sainte Agathe","Saint Gaston","Sainte Eugènie","Sainte Jacqueline","Sainte Apolline","Saint Arnaud","Sainte Notre Dame de Lourdes","Saint Félix","Sainte Béatrice","Saint Valentin","Saint Claude","Sainte Julienne","Saint Alexis","Sainte Bernadette","Saint Gabin","Sainte Aimée","Mercredi des Cendres","Sainte Isabelle","Saint Lazare","Sainte Modeste","Saint Roméo","Saint Nestor","Sainte Honorine","Saint Romain","Saint Auguste"
],
[
"Saint Aubin","Saint Charles le Bon","Saint Guénolé","Saint Casimir","Saint Olive","Sainte Colette","Sainte Félicité","Saint Jean de Dieu","Sainte Françoise","Saint Vivien","Sainte Rosine","Sainte Justine","Saint Rodrigue","Sainte Mathilde","Sainte Louise","Sainte Bénédicte","Saint Patrice","Saint Cyrille","Saint Joseph","Equinoxe de Printemps","Sainte Clémence","Sainte Léa","Saint Victorien","Sainte Karine","Sainte Anne","Sainte Larissa","Saint Habib","Saint Gontran","Sainte Gwladys","Saint Amédée","Saint Benjamin"
],
[
"Saint Hugues","Sainte Sandrine","Saint Richard","Saint Isidore","Sainte Irène","Saint Marcellin","Saint Jean-Baptiste de la Salle","Sainte Julie","Saint Gautier","Saint Fulbert","Saint Stanislas","Saint Jules","Sainte Ida","Saint Maxime","Saint Paterne","Saint Benoît-Joseph","Saint Anicet","Saint Parfait","Sainte Emma","Sainte Odette","Saint Anselme","Saint Alexandre","Saint Georges","Saint Fidèle","Saint Marc","Sainte Alida","Sainte Zita","Sainte Valérie","Sainte Catherine de Sienne","Saint Robert"
],
[
"Fête du travail","Saint Boris","Saint Philippe","Saint Sylvain","Saint Judith","Saint Prudence","Sainte Gisèle","Armistice de 1945","Saint Pacôme","Sainte Solange","Sainte Estelle","Saint Achille","Sainte Rolande","Saint Matthias","Sainte Denise","Saint Honoré","Saint Pascal","Saint Eric","Saint Yves","Saint Bernardin","Saint Constantin","Saint Emile","Saint Didier","Saint Donatien","Sainte Sophie","Saint Bérenger","Saint Augustin","Saint Germain","Saint Aymar","Saint Ferdinand","Saint Ferdinand"
],
[
"Saint Justin","Sainte Blandine","Saint Kévin","Sainte Clotilde","Saint Igor","Saint Norbert","Saint Gilbert","Saint Médard","Sainte Diane","Saint Landry","Saint Barnabé","Saint Guy","Saint Antoine de Padoue","Sainte Elisée","Sainte Germaine","Saint Jean-François Régis","Saint Hervé","Saint Léonce","Saint Romuald","Saint Silvère","Solstice d'été","Saint Alban","Sainte Audrey","Saint Jean-Baptiste","Saint Prosper","Saint Anthelme","Saint Fernand","Saint Irénée","Saint Pierre","Saint Martial"
],
[
"Saint Thierry","Saint Martinien","Saint Thomas","Saint Florent","Saint Antoine","Sainte Mariette","Saint Raoul","Saint Thibault","Sainte Amandine","Saint Ulrich","Saint Benoît","Saint Olivier","Saint Henri","Fête Nationale","Saint Donald","Fête de Notre Dame du Mont Carmel","Sainte Charlotte","Saint Frédéric","Saint Arsène","Sainte Marina","Saint Victor","Sainte Marie-Madeleine","Sainte Brigitte","Sainte Christine","Saint Jacques","Sainte Anne","Sainte Nathalie","Saint Samson","Sainte Marthe","Sainte Juliette","Saint Ignace de Loyola"
],
[
"Saint Alphonse","Saint Julien Eymard","Sainte Lydie","Saint Jean-Marie Vianney","Saint Abel","Fête de la Transfiguration","Saint Gaétan","Saint Dominique","Saint Amour","Saint Laurent","Sainte Claire","Sainte Clarisse","Saint Hippolyte","Saint Evrard","Fête de l'Assomption","Sainte Armel","Saint Hyacinthe","Sainte Hélène","Saint Jean-Eudes","Saint Bernard","Saint Christophe","Saint Fabrice","Sainte Rose de Lima","Saint Barthélémy","Saint Louis","Sainte Natacha","Sainte Monique","Saint Augustin","Sainte Sabine","Saint Fiacre","Saint Aristide"
],
[
"Saint Gilles","Sainte Ingrid","Saint Grégoire","Sainte Rosalie","Sainte Raïssa","Saint Bertrand","Sainte Reine","Fête de la Nativité","Saint Alain","Sainte Inès","Saint Adelphe","Saint Apollinaire","Saint Aimé","Fête de la Croix Glorieuse","Saint Roland","Sainte Edith","Saint Renaud","Sainte Nadège","Sainte Emilie","Saint Davy","Saint Matthieu","Saint Maurice","Equinoxe d'Automne","Sainte Thècle","Saint Hermann","Saint Côme","Saint Vincent de Paul","Saint Venceslas","Saint Michel","Saint Jérôme"
],
[
"Sainte Thérèse de l'Enfant Jésus","Saint Léger","Saint Gérard","Saint François d'Assise","Sainte Fleur","Saint Bruno","Saint Serge","Sainte Pélagie","Saint Denis","Saint Ghislain","Saint Firmin","Saint Wilfried","Saint Géraud","Saint Juste","Saint Thérèse d'Avila","Sainte Edwige","Saint Baudoin","Saint Luc","Saint René","Sainte Adeline","Sainte Céline","Sainte Elodie","Saint Jean de Capistran","Saint Florentin","Saint Crépin","Saint Dimitri","Sainte Emeline","Saint Jude","Saint Narcisse","Sainte Bienvenue","Saint Quentin"
],
[
"Toussaint","Fête des défunts","Saint Hubert","Saint Charles","Sainte Sylvie","Sainte Bertille","Sainte Carine","Saint Geoffroy","Saint Théodore","Saint Léon","Armistice de 1918","Saint Christian","Saint Brice","Saint Sidoine","Saint Albert","Sainte Marguerite","Sainte Elisabeth","Sainte Aude","Saint Tanguy","Saint Edmond","Présence de Marie","Sainte Cécile","Saint Clément","Sainte Flora","Sainte Catherine","Sainte Delphine","Saint Sévrin","Saint Jacques de la Marche","Saint Saturnin","Saint André"
],
[
"Sainte Florence","Sainte Viviane","Saint François-Xavier","Sainte Barbara","Saint Gérald","Saint Nicolas","Sainte Ambroise","Fête de l'Immaculée Conception","Saint Pierre Fourier","Saint Romaric","Saint Daniel","Sainte Jeanne-Françoise de Chantal","Sainte Lucie","Sainte Odile","Sainte Ninon","Sainte Alice","Saint Gaël","Saint Gatien","Saint Urbain","Saint Théophile","Solstice d'Hiver","Sainte Françoise-Xavière","Saint Armand","Sainte Adèle","Noël","Saint Etienne","Saint Jean","Saints Innocents","Saint David","Saint Roger","Saint Sylvestre"
]
]

def getToday():
   paques = easter(date.today().year)
   fetes[paques.month-1][paques.day-1] = "Pâques"
   #print(fetes[paques.month-1][paques.day-1] + " : " + str(paques.day) + "/" + str(paques.month) + "/" + str(paques.year))

   temp = paques + timedelta(days=1)
   fetes[temp.month-1][temp.day-1] = "Lundi de Pâques"
   #print(fetes[temp.month-1][temp.day-1] + " : " + str(temp.day) + "/" + str(temp.month) + "/" + str(temp.year))

   temp = paques - timedelta(days=2)
   fetes[temp.month-1][temp.day-1] = "Vendredi Saint"
   #print(fetes[temp.month-1][temp.day-1] + " : " + str(temp.day) + "/" + str(temp.month) + "/" + str(temp.year))

   temp = paques - timedelta(days=47)
   fetes[temp.month-1][temp.day-1] = "Mardi Gras"
   #print(fetes[temp.month-1][temp.day-1] + " : " + str(temp.day) + "/" + str(temp.month) + "/" + str(temp.year))

   temp = paques + timedelta(days=39)
   fetes[temp.month-1][temp.day-1] = "Ascension"
   #print(fetes[temp.month-1][temp.day-1] + " : " + str(temp.day) + "/" + str(temp.month) + "/" + str(temp.year))

   temp = paques + timedelta(days=49)
   fetes[temp.month-1][temp.day-1] = "Pentecôte"
   #print(fetes[temp.month-1][temp.day-1] + " : " + str(temp.day) + "/" + str(temp.month) + "/" + str(temp.year))

   temp = paques + timedelta(days=50)
   fetes[temp.month-1][temp.day-1] = "Lundi de Pentecôte"
   #print(fetes[temp.month-1][temp.day-1] + " : " + str(temp.day) + "/" + str(temp.month) + "/" + str(temp.year))

   temp = date(date.today().year,3,1)
   temp += timedelta(days=(6 - temp.weekday()))
   fetes[temp.month-1][temp.day-1] = "Fête des Grands-Mères"
   #print(fetes[temp.month-1][temp.day-1] + " : " + str(temp.day) + "/" + str(temp.month) + "/" + str(temp.year))

   temp = date(date.today().year,5,31)
   temp -= timedelta(days=((1+ temp.weekday())%7))
   if fetes[temp.month-1][temp.day-1] == "Pentecôte":
      temp += timedelta(days=7)
   fetes[temp.month-1][temp.day-1] = "Fête des Mères"
   #print(fetes[temp.month-1][temp.day-1] + " : " + str(temp.day) + "/" + str(temp.month) + "/" + str(temp.year))

   temp = date(date.today().year,6,15)
   temp += timedelta(days=(6-temp.weekday()))
   fetes[temp.month-1][temp.day-1] = "Fête des Pères"
   #print(fetes[temp.month-1][temp.day-1] + " : " + str(temp.day) + "/" + str(temp.month) + "/" + str(temp.year))

   temp = date(date.today().year,12,25)
   temp -= timedelta(days=22)
   temp -= timedelta(days=((1+ temp.weekday())%7))
   fetes[temp.month-1][temp.day-1] = "Avent"
   #print(fetes[temp.month-1][temp.day-1] + " : " + str(temp.day) + "/" + str(temp.month) + "/" + str(temp.year))

   temp = date.today()
   return fetes[temp.month-1][temp.day-1]

def init(root_path):
   log.cat("OK!", end="")
   return

def refresh(cron):
   global fete_today, last_update
   if int(time()) < (last_update + cron):
      return
   log.write("Refreshing fete...",end="")
   last_update = time()
   fete_today = getToday()
   log.cat("OK!")
   return

def draw(ctx, x, y):
   global fete_today
   ctx.set_source_rgba(1, 1, 1, 1)
   ctx.select_font_face('Droid Sans')
   ctx.set_font_size(14)
   ctx.move_to(x,y)
   locale.setlocale(locale.LC_ALL, 'fr_FR.utf8')
   ctx.text_path(strftime("%A %d %B", localtime())+" - " + fete_today)
   ctx.fill()
